package com.steerinfo.dil.controller;

import com.steerinfo.dil.model.AmsshipCargoTransferResult;
import com.steerinfo.dil.model.AmsshipDeliveryAttorney;
import com.steerinfo.dil.model.OmsshipShipmentInstructions;
import com.steerinfo.dil.service.IAmsshipCargoTransferResultService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.math.BigDecimal;
import java.util.Map;

/**
 * AmsshipCargoTransferResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:36
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipCargoTransferResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/amsshipcargotransferresults")
public class AmsshipCargoTransferResultController extends BaseRESTfulController {

    @Autowired
    IAmsshipCargoTransferResultService amsshipCargoTransferResultService;
    @Autowired
    ColumnDataUtil columnDataUtil;
    @ApiOperation(value="展示货权转移表", notes="分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "apiId", value = "66", required = false, dataType = "BigDecimal"),
    })
    @PostMapping(value = "/getAmsshipCargoTranferResultList")
    public RESTfulResult getAmsshipCargoTranferResultList(@RequestBody(required = false) Map<String,Object> mapVal,
                                                          Integer pageNum,
                                                          Integer pageSize,
                                                          Integer apiId){
        List<Map<String,Object>> list = amsshipCargoTransferResultService.seletCargoTransfer(mapVal);
        PageHelper.startPage(pageNum, pageSize);
        //分页查询数据
        List<Map<String, Object>> columnList = amsshipCargoTransferResultService.seletCargoTransfer(mapVal);
        PageListAdd data = columnDataUtil.tableColumnData(apiId, list, columnList);
        return success(data);
    }
    //新增
    @ApiOperation(value="新增", notes="根据amsshipCargoTransferResult对象创建")
    @ApiImplicitParam(name = "amsshipCargoTransferResult", value = "详细实体amsshipCargoTransferResult", required = true, dataType = "amsshipCargoTransferResult", paramType = "java.util.Map")
    @PostMapping(value = "/insertamsshipCargoTransferResult")
    public RESTfulResult insertamsshipCargoTransferResult(@RequestBody AmsshipCargoTransferResult amsshipCargoTransferResult){
        int code=amsshipCargoTransferResultService.insertSelective(amsshipCargoTransferResult);
        System.out.println(code);
        return success(code);
    }
    //根据id获取信息
    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal")
    @PostMapping(value ="/selectByCargoTranferResultId/{cargoTransferResultId}")
    public RESTfulResult selectByCargoTranferResultId(@PathVariable("cargoTransferResultId") Integer cargoTransferResultId){
        System.out.println(cargoTransferResultId);
        List<Map<String,Object>> amsshipCargoTransferResult = amsshipCargoTransferResultService.selectByOrder(cargoTransferResultId);
        System.out.println(amsshipCargoTransferResult);
        return success(amsshipCargoTransferResult);
    }
    //修改
    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的amsshipDeliveryAttorney信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal"),
            @ApiImplicitParam(name = "amsshipDeliveryAttorney", value = "详细实体amsshipDeliveryAttorney", required = true, dataType = "amsshipDeliveryAttorney")
    })
    @PostMapping(value = "/editCargoTransferResult", produces  = "application/json;charset=UTF-8")
    public RESTfulResult editCargoTransferResult(@RequestBody  AmsshipCargoTransferResult  amsshipCargoTransferResult){
        amsshipCargoTransferResultService.updateByPrimaryKeySelective(amsshipCargoTransferResult);
        System.out.println(amsshipCargoTransferResult);
        return success(amsshipCargoTransferResult);
    }
    //    删除
    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal")
    @PostMapping(value ="/deleteByCargoId/{cargoTransferResultId}")//BigDecimal
    public RESTfulResult deleteByCargoId(@PathVariable("cargoTransferResultId") Integer cargoTransferResultId){
        System.out.println(cargoTransferResultId);
        AmsshipCargoTransferResult amsshipCargoTransferResult = new AmsshipCargoTransferResult();
        amsshipCargoTransferResult.setCargoTransferResultId(new BigDecimal(cargoTransferResultId));
        BigDecimal deleted = new BigDecimal(1);
        amsshipCargoTransferResult.setDeleted(deleted);
        amsshipCargoTransferResultService.updateByPrimaryKeySelective(amsshipCargoTransferResult);
        return success();
    }
    //得到收货人id
    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal")
    @GetMapping(value = "/getGroupId")
    public RESTfulResult getGroup(){
        List<Map<String,Object>> list= amsshipCargoTransferResultService.getGroup();
        return success(list);
    }
    //得到货物id
    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal")
    @GetMapping(value = "/getCargoId")
    public RESTfulResult getCargoId(){
        List<Map<String,Object>> list= amsshipCargoTransferResultService.getCargoId();
        return success(list);
    }
    //得到批次id
    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal")
    @GetMapping(value = "/insertBetchId")
    public RESTfulResult insertBetchId(){
        List<Map<String,Object>> list= amsshipCargoTransferResultService.insertBetchId();
        return success(list);
    }
}
